/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2004 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2001-2004 by Dep. of Computer Science and Engineering
 *                   Tomakomai National College of Technology, JAPAN
 *
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: route_cfg.c,v 1.1.1.1 2004/04/21 00:49:31 abe Exp abe $
 */

/* 
 *  롼ƥɽ
 */

#include <t_services.h>

#include <tinet_defs.h>
#include <tinet_config.h>

#include <net/route.h>

#ifdef SUPPORT_LOOP

T_RT_ENTRY routing_tbl[NUM_ROUTE_ENTRY] = {
	{ 0, 0, 0 },
	};

#endif	/* of #ifdef SUPPORT_LOOP */

#ifdef SUPPORT_PPP

T_RT_ENTRY routing_tbl[NUM_ROUTE_ENTRY] = {
	{ 0, 0, 0 },
	};

#endif	/* of #ifdef SUPPORT_PPP */

#ifdef SUPPORT_ETHER

T_RT_ENTRY routing_tbl[NUM_ROUTE_ENTRY] = {
	{ 0,		0,		0xac19818c	},	/* default,            gateway: 172.25.129.140 */
	{ 0xac198100,	0xffffff00,	0		},	/* 172.25.129.0/24,    gateway: DIRECT         */
	{ 0xffffffff,	0xffffffff,	0		},	/* 255.255.255.255/32, gateway: DIRECT         */
	};

#endif	/* of #ifdef SUPPORT_ETHER */
