/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2004 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2001-2004 by Dep. of Computer Science and Engineering
 *                   Tomakomai National College of Technology, JAPAN
 *
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: tinet_app_config.h,v 1.1.1.1 2004/04/21 00:49:31 abe Exp abe $
 */

#ifndef _TINET_APP_CONFIG_H_
#define _TINET_APP_CONFIG_H_

/*
 *  󥿡ͥåȥץȥեߥ꡼Υݡ
 *
 *    Makefile ǻꤷƤɤ
 */

/*#define SUPPORT_INET4		   TCP/IP, IPv4			*/
/*#define SUPPORT_TCP		   TCP				*/
/*#define SUPPORT_UDP		   UDP				*/

/*  ǡؤΥͥåȥ󥿥ե򤹤	*/
/*  줫ĤǤ롣				*/

/*#define SUPPORT_PPP		   Point to Point Protocol	*/
/*#define SUPPORT_LOOP		   Local Loop Back		*/
/*#define SUPPORT_ETHER		   Ethernet			*/

/*
 *  TCP/IP ˴ؤ
 */

/* IP ˴ؤ */

#ifdef SUPPORT_PPP

#if 1
#define IPV4_ADDR_LOCAL		0xc0a80115	/* 192.168.1.21 */
#else
#define IPV4_ADDR_LOCAL		0		/* ˳ƤƤ餦	*/
#endif

#if 1
#define IPV4_ADDR_REMOTE	0xc0a8011f	/* 192.168.1.31 */
#else
#define IPV4_ADDR_REMOTE	0		/* ˳ƤƤ餦	*/
#endif

#define NUM_ROUTE_ENTRY		1

#endif	/* of #ifdef SUPPORT_PPP */

#ifdef SUPPORT_ETHER

#ifdef DHCP_CFG

#define IPV4_ADDR_LOCAL		0x00000000
#define IPV4_ADDR_LOCAL_MASK	0x00000000

#else	/* of #ifdef DHCP_CFG */

#define IPV4_ADDR_LOCAL		0xac198162	/* 172.25.129.98	*/
#define IPV4_ADDR_LOCAL_MASK	0xffffff00	/* 255.255.255.0	*/

#endif	/* of #ifdef DHCP_CFG */

#define NUM_ROUTE_ENTRY		4

#endif	/* of #ifdef SUPPORT_ETHER */

#ifdef SUPPORT_LOOP

#define NUM_ROUTE_ENTRY		1

#endif	/* of #ifdef SUPPORT_LOOP */

/*
 *  ǡ (ͥåȥ󥿥ե) ˴ؤ
 */

/*
 *  PPP ˴ؤ
 */

#define HDLC_PORTID		1	/* HDLC(PPP)Ѥ륷ꥢݡֹ	*/

/*#define PPP_IDLE_TIMEOUT	(180*NET_TIMER_HZ)*/
					/* ǤޤǤΥɥ֡		*/
					/* ǤʤϥȥȤ롣	*/

/*#define PPP_CFG_MODEM			 ǥ³ξϥȤ򳰤	*/

#define MODEM_CFG_INIT		"ATE1&D0&S0\\V0\\Q1S0=1"
					/* ǥʸ			*/
					/* NTT DoComo Х륢ץ 96F 	*/
					/*   E1: Хå			*/
					/*  &D0: ER̵			*/
					/*  &S0: DR ON			*/
					/*  \V0: ꥶȥ TYPE 1		*/
					/*  \Q1: XON/XOFF ե		*/
					/* S0=1: ư忮󥰲 = 1 	*/

#define MODEM_CFG_PHONE_NUMBER	"090-xxxx-9242"

					/* ε			*/
#define DEF_LCP_LOCAL_CFGS	(LCP_CFG_MRU|LCP_CFG_ACCM|LCP_CFG_MAGIC|LCP_CFG_ACCOMP|LCP_CFG_PCOMP|LCP_CFG_PAP)

					/* ˵ε		*/
#define DEF_LCP_REMOTE_CFGS	(LCP_CFG_MRU|LCP_CFG_ACCM|LCP_CFG_MAGIC|LCP_CFG_ACCOMP|LCP_CFG_PCOMP|LCP_CFG_PAP)

/*
 *  ǧڤ˴ؤ
 */

#define AUTH_CFG_CLIENT		   	/* ǧڥ饤ȥ⡼ɤλϥȤ򳰤	*/
#define AUTH_CFG_SERVER			/* ǧڥХ⡼ɤλϥȤ򳰤		*/

#define AUTH_LOCAL_USER		"h8"		/* ۥȤؤΥǧڥ桼̾	*/
#define AUTH_LOCAL_PASSWD	"3048f"		/* ۥȤؤΥǧڥѥ	*/
#define AUTH_REMOTE_USER	"pen3"		/* ؤΥǧڥ桼̾		*/
#define AUTH_REMOTE_PASSWD	"600MHz"	/* ؤΥǧڥѥ		*/

#endif /* _TINET_APP_CONFIG_H_ */
