/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2004 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2001-2004 by Dep. of Computer Science and Engineering
 *                   Tomakomai National College of Technology, JAPAN
 *
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: net_rename.h,v 1.1.1.1 2004/04/21 00:43:22 abe Exp abe $
 */

#ifndef _NET_RENAME_H_
#define _NET_RENAME_H_

/*
 *  ѥͥåȥ󥿥ե̾Υ͡
 */

/* net/ethernet.c */

#define ether_broad_cast_addr	_tinet_ether_broad_cast_addr
#define ether_ipv4_addr_local	_tinet_ether_ipv4_addr_local
#define ether_ipv4_addr_local_mask	\
				_tinet_ether_ipv4_addr_local_mask

#define	ether_raw_output	_tinet_ether_raw_output
#define ether_output		_tinet_ether_output

/* net/if.c */

#ifdef SUPPORT_ETHER

#define ifinit			_tinet_ifinit

#endif	/* of #ifdef SUPPORT_ETHER */

/* net/net_buf.c */

#define get_net_buf_entry	_tinet_get_net_buf_entry
#define get_num_net_buf_entry	_tinet_get_num_net_buf_entry
#define tget_net_buf		_tinet_tget_net_buf
#define rel_net_buf		_tinet_rel_net_buf

/* net/net_count.c */

#define net_count_ppp			_tinet_net_count_ppp
#define net_buf				_tinet_net_buf
#define net_count_ppp_lcp_in_octets	_tinet_net_count_ppp_lcp_in_octets
#define net_count_ppp_lcp_in_packets	_tinet_net_count_ppp_lcp_in_packets
#define net_count_ppp_ipcp_in_octets	_tinet_net_count_ppp_ipcp_in_octets
#define net_count_ppp_ipcp_in_packets	_tinet_net_count_ppp_ipcp_in_packets
#define net_count_ppp_upap_in_octets	_tinet_net_count_ppp_upap_in_octets
#define net_count_ppp_upap_in_packets	_tinet_net_count_ppp_upap_in_packets
#define net_count_hdlc			_tinet_net_count_hdlc
#define net_count_loop			_tinet_net_count_loop
#define net_count_ether			_tinet_net_count_ether
#define net_count_arp			_tinet_net_count_arp
#define net_count_ether_nic		_tinet_net_count_ether_nic
#define net_count_ether_nic_cols	_tinet_net_count_ether_nic_cols
#define net_count_ether_nic_resets	_tinet_net_count_ether_nic_resets
#define net_count_ether_nic_no_bufs	_tinet_net_count_ether_nic_no_bufs
#define net_count_ether_nic_rxb_qovrs	_tinet_net_count_ether_nic_rxb_qovrs
#define net_count_ether_nic_txb_qovrs	_tinet_net_count_ether_nic_txb_qovrs
#define net_count_ether_nic_timeouts	_tinet_net_count_ether_nic_timeouts
#define net_count_ip4			_tinet_net_count_ip4
#define net_count_tcp			_tinet_net_count_tcp
#define net_count_udp			_tinet_net_count_udp
#define net_count_icmp4			_tinet_net_count_icmp4

/* net/net_subr.c */

#define convert_hexdigit	_tinet_convert_hexdigit
#define mac2str			_tinet_mac2str

/* net/net_timer.c */

#define timeout			_tinet_timeout
#define untimeout		_tinet_untimeout

/* net/route.c */

#define rtalloc			_tinet_rtalloc

/* route_cfg.c */

#define routing_tbl		_tinet_routing_tbl

#ifdef SUPPORT_PPP

#endif	/* of #ifdef SUPPORT_PPP */

#ifdef SUPPORT_LOOP

#endif	/* of #ifdef SUPPORT_LOOP */

#endif	/* of #ifndef _NET_RENAME_H_ */
