/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2004 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2001-2004 by Dep. of Computer Science and Engineering
 *                   Tomakomai National College of Technology, JAPAN
 *
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: tcp_var.h,v 1.1.1.1 2004/04/21 00:46:19 abe Exp abe $
 */

/*
 * Copyright (c) 1982, 1986, 1993, 1994, 1995
 *	The Regents of the University of California.  All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *	This product includes software developed by the University of
 *	California, Berkeley and its contributors.
 * 4. Neither the name of the University nor the names of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 *	@(#)tcp_var.h	8.4 (Berkeley) 5/24/95
 * $FreeBSD: src/sys/netinet/tcp_var.h,v 1.49.2.1 1999/08/29 16:29:57 peter Exp $
 */
 
#ifndef _TCP_VAR_H_
#define _TCP_VAR_H_

/*
 *  TCP ո
 */

typedef struct t_tcp_crep {
	/* ɸ */
	ATR		repatr;		/* ո°		*/
	T_IPV4EP	myaddr;		/* ʬΥɥ쥹	*/
	/* ¸ */
	} T_TCP_CREP;

/*
 *  TCP ̿ü
 */

typedef UW T_TCP_SEQ;
typedef UH T_TCP_SEG;
typedef UH T_TCP_WND;

typedef struct t_tcp_ccep {
	/* ɸ */
	ATR		cepatr;		/* ̿ü°			*/
	VP		sbuf;		/* ѥХåե		*/
	INT		sbufsz;		/* ѥХåե		*/
	VP		rbuf;		/* ѥХåե		*/
	INT		rbufsz;		/* ѥХåե		*/
	FP		callback;	/* Хå			*/
	/* ¸ */
	ID		semid_lock;		/* ̿üå	*/
	ID		semid_sbuf_ready;	/* Хåեͭ	*/
	ID		semid_rbuf_ready;	/* Хåեǡͭ	*/
	ID		flgid;		/* ٥ȥե饰		*/
	ID		snd_tskid;	/* ̻		*/
	ID		rcv_tskid;	/* ̻		*/
	UB		*sbuf_rptr;	/* ɤ߽Фݥ		*/
	UB		*sbuf_wptr;	/* ѽ񤭹ߥݥ		*/
	UB		*rbuf_rptr;	/* ɤ߽Фݥ		*/
	UB		*rbuf_wptr;	/* ѽ񤭹ߥݥ		*/
	struct
	t_tcp_ccep	*next;		/* ̿üΥꥹ		*/
	T_TCP_SEQ	snd_ssthresh;	/* ԥɥ(snd_cwnd)	*/
					/* 			*/
	T_TCP_TIME	rxtcur;		/* ߤκॢ		*/
	T_TCP_TIME	srtt;		/* ʿ경줿 RTT		*/
	T_TCP_TIME	rttvar;		/* ʿ경줿ʬ		*/
	UW		rttmin;		/* RTT ˵Ǿ		*/
	T_TCP_WND	snd_cwnd;	/* ԥɥ		*/

	/*
	 *  κȥ	
	 *
	 *    ꥸʥǤϡ̤ΥȤκ祵 (t_maxseg) ȡ
	 *    ץդΥȤκ祵 (t_maxopd) ̤
	 *    ʤäƤ롣ϡߤΥ󥿡ͥåȤǤϡץդ
	 *    ȤΤۤ¿Ƥ뤿Ǥ롣
	 *    ܼǤϡ祻ȥץʳΥץ
	 *    ʤΤǡt_maxseg λѤ롣
	 */
	T_TCP_SEG	maxseg;

	H		snd_tfn;	/* ư API ǽ	*/
	H		rcv_tfn;	/* ư API ǽ	*/
	H		snd_nblk_tfn;	/* ư API ǽ	*/
	H		rcv_nblk_tfn;	/* ư API ǽ	*/
	T_IPV4EP 	*p_dstaddr;	/* Υɥ쥹ؤΥݥ	*/
	T_IPV4EP 	*p_myaddr;	/* ʬΥɥ쥹ؤΥݥ	*/
	VP		snd_data;	/* ǡΰƬɥ쥹	*/
	INT		snd_len;	/* ǡΰĹ		*/
	VP		rcv_data;	/* ǡΰƬɥ쥹	*/
	INT		rcv_len;	/* ǡΰĹ		*/
	VP	 	*snd_p_buf;	/* ХåեؤΥݥ	*/
	VP	 	*rcv_p_buf;	/* ХåեؤΥݥ	*/

	/*
	 *  ʹߤΥС tcp_init_cep() ؿǥꥢ롣
	 */

	T_TCP_TIME	timer[NUM_TCP_TIMERS];	/* TCP Υ		*/
	T_IPV4EP	dstaddr;	/* Υɥ쥹		*/
	T_IPV4EP	myaddr;		/* ʬΥɥ쥹		*/
	T_TCP_CREP	*rep;		/* ո			*/
	T_NET_BUF	*segq;		/* ȥ塼		*/

	T_TCP_SEQ	snd_una;	/* ̤ǧκǾ SEQ Ĥޤ	*/
					/* ǧ줿 SEQ		*/
	T_TCP_SEQ	snd_max;	/*  SEQ		*/
	T_TCP_SEQ	snd_nxt;	/*  SEQ		*/
	T_TCP_SEQ	snd_up;		/* ۵ޥݥ		*/
	T_TCP_SEQ	snd_wl1;	/* 󥦥ɤ򹹿 SEQ	*/
	T_TCP_SEQ	snd_wl2;	/* 󥦥ɤ򹹿 ACK	*/
	T_TCP_SEQ	iss;		/* ʬ SEQ ν		*/
	T_TCP_SEQ	irs;		/*  SEQ ν		*/
	T_TCP_SEQ	rcv_nxt;	/* ԤƤǾ SEQ	*/
	T_TCP_SEQ	rcv_adv;	/* ԤƤ SEQ	*/
	T_TCP_SEQ	rcv_wnd;	/* ǽʥɥ	*/
	T_TCP_SEQ	rcv_up;		/* ۵ޥݥ		*/
	T_TCP_SEQ	rtseq;		/* ַ¬Ϥ᤿ SEQ		*/
	T_TCP_SEQ	last_ack_sent;	/* Ǹ ACK		*/
	T_TCP_TIME	idle;		/* ɥ			*/
	ER		error;		/* Ʊȯ顼		*/
	ER		net_error;	/* ͥåȥΥ顼	*/
	T_TCP_WND	snd_wnd;	/* μǽɥ	*/
	T_TCP_WND	max_sndwnd;	/* ޤǤκɥ	*/
	UH		rtt;		/* 			*/
	UH		sbuf_count;	/* Хåեλ極	*/
	UH		rbuf_count;	/* Хåեλ極	*/
	UH		rcv_buf_len;	/* tcp_rcv_buf γĹ	*/
	UH		get_buf_len;	/* tcp_rcv_buf γĹ	*/
	UH		flags;		/* ̿üե饰		*/
	UB		rxtshift;	/*  log(2)		*/
	UB		fsm_state;	/* FSM 			*/
	UB		dupacks;	/*  ACK 			*/

	} T_TCP_CCEP;

/*
 *  ̿üե饰
 */

#define CEP_FLG_ACK_NOW		0x0001	/* ľ ACK 롣	*/
#define CEP_FLG_DEL_ACK		0x0002	/* ACK ٱ䤹롣		*/
#define CEP_FLG_SENT_FIN	0x0004	/* FIN äƤ롣		*/
#define CEP_FLG_NEED_SYN	0x0008	/* SYN 롣		*/
#define CEP_FLG_NEED_FIN	0x0010	/* FIN 롣		*/
#define CEP_FLG_FORCE		0x0020	/* 			*/
#define CEP_FLG_NO_PUSH		0x0040	/* push ʤ			*/
#define CEP_FLG_NO_DELAY	0x0080	/* ٱ䤷ʤ			*/
#define CEP_FLG_FORCE_CLEAR	0x0100	/* ե饰򥯥ꥢ롣*/
#define CEP_FLG_POST_OUTPUT	0x0200	/* 򳫻Ϥ롣		*/

/*
 *  ̿ü٥ȥե饰
 */

#define CEP_EVT_ESTABLISHED	0x00000001	/* ͥΩ	*/
#define CEP_EVT_CLOSED		0x00000002	/* ̤Ѿ		*/
#define CEP_EVT_ALL		0xffffffff	/* ٥		*/

/*
 *  ɲ API ǽݥ
 */

/* TCP ط */

#define TFN_TCP_UNDEF		(0)

/*
 *  srtt:   ʿ경줿 RTT
 *  rttvar: ʿ경줿ʬ
 *  rtt:    ¬ꤵ줿
 *
 *  ʿ경줿 RTT (srtt) ʿ경줿ʬ (rttvar) 
 *  Ƿ׻뤿ˡեȤƥ뤹롣
 *  srtt  2 ʾʲ 3 ӥåȡ
 *  rttvar  2 ʾʲ 2 ӥåȤݻ롣
 */

#define TCP_DELTA_SHIFT		2
			/* ʬ = rtt/8 + srtt*7/8 η׻ΤΥե	*/
#define TCP_SRTT_SHIFT		(TCP_DELTA_SHIFT + 3)
					/* srtt Υե͡3(+2)ӥå	*/
#define TCP_RTTVAR_SHIFT	(TCP_DELTA_SHIFT + 2)
					/* rttvar Υե͡2(+2)ӥå	*/
#define TCP_SRTT_SCALE		(1<<TCP_SRTT_SHIFT)
#define TCP_RTTVAR_SCALE	(1<<TCP_RTTVAR_SHIFT)

/*
 *  ®ž򳫻Ϥ ACK Τ
 */

#define MAX_TCP_REXMT_THRESH	3

/*
 *  ȥ塼Ǥ TCP إå
 */

typedef struct t_tcp_q_hdr {
	UH	sport;		/* ݡֹ			*/
	UH	dport;		/* ݡֹ			*/

	UW	seq;		/* SEQ ֹ				*/

	T_NET_BUF *next;	/* Υȡ ACK ֹ (ack)	*/

	UB	off;		/* ǡեå(4ӥå)		*/
	UB	flags;		/* ե饰(6ӥå)			*/
	UH	win;		/* ɥ			*/

	UH	len;		/* SDU Ĺϥå (sum)		*/
	UH	urp;		/* ۵ޥݥ				*/
	} T_TCP_Q_HDR;

#define GET_TCP_Q_HDR(nbuf)	((T_TCP_Q_HDR*)((nbuf)->buf + GET_IF_IP4_HDR_SIZE(nbuf)))

/*
 *  ֥ ID κǾͤ
 */

#define	TMIN_TCP_CREPID	1	/* TCP ո   ID κǾ */
#define	TMIN_TCP_CCEPID	1	/* TCP ̿ü ID κǾ */

/*
 *  ѿ
 */

extern T_TCP_CREP tcp_crep[];
extern T_TCP_CCEP tcp_ccep[];
extern UB tcp_initialized;
extern const ID tmax_tcp_crepid;
extern const ID tmax_tcp_ccepid;

/*
 *  ؿߥ졼ޥ
 */

#define VALID_TCP_CREPID(id)	(TMIN_TCP_CREPID<=(id)&&(id)<=tmax_tcp_crepid)
#define VALID_TCP_CCEPID(id)	(TMIN_TCP_CCEPID<=(id)&&(id)<=tmax_tcp_ccepid)

#define INDEX_TCP_CREP(id)	((id)-TMIN_TCP_CREPID)
#define INDEX_TCP_CCEP(id)	((id)-TMIN_TCP_CCEPID)

#define GET_TCP_CREP(id)	(&(tcp_crep[INDEX_TCP_CREP(id)]))
#define GET_TCP_CCEP(id)	(&(tcp_ccep[INDEX_TCP_CCEP(id)]))

#define GET_TCP_CREPID(rep)	(((rep)-tcp_crep)+TMIN_TCP_CREPID)
#define GET_TCP_CCEPID(cep)	(((cep)-tcp_ccep)+TMIN_TCP_CCEPID)

#define IS_TFN_TCP_RCV(t)	((t)==TFN_TCP_ACP_CEP||(t)==TFN_TCP_RCV_DAT||\
				 (t)==TFN_TCP_CLS_CEP||\
				 (t)==TFN_TCP_RCV_BUF||(t)==TFN_TCP_REL_BUF||\
				 (t)==TFN_TCP_RCV_OOB)

#define VALID_TFN_TCP_CAN(t)	((t)==TFN_TCP_ACP_CEP||(t)==TFN_TCP_CON_CEP||\
				 (t)==TFN_TCP_CLS_CEP||\
				 (t)==TFN_TCP_SND_DAT||(t)==TFN_TCP_RCV_DAT||\
				 (t)==TFN_TCP_GET_BUF||(t)==TFN_TCP_RCV_BUF||\
				 (t)==TFN_TCP_SND_OOB||\
				 (t)==TFN_TCP_ALL)

/*
 *  ؿ
 */

extern void tcp_input (T_NET_BUF *data);
extern ER tcp_output (T_TCP_CCEP *cep, TMO tmout);
extern void tcp_init (void);
extern void tcp_init_iss (void);
extern T_TCP_CCEP *tcp_close (T_TCP_CCEP *cep);
extern T_TCP_CCEP *tcp_drop  (T_TCP_CCEP *cep, ER errno);
extern void tcp_respond (T_NET_BUF *nbuf, T_TCP_CCEP *cep, T_TCP_SEQ ack,
                         T_TCP_SEQ seq, int flags, TMO tmout);
extern ER tcp_get_segment (T_NET_BUF **nbuf, T_TCP_CCEP *cep, int optlen,
                           int len, TMO tmout);
extern void tcp_sbuf_drop (T_TCP_CCEP *cep, int len);
extern void tcp_rbuf_append (T_TCP_CCEP *cep, T_NET_BUF *input);
extern void tcp_seg_fill (T_TCP_CCEP *cep, T_NET_BUF *output,
                          int len, int off);
extern void tcp_init_cep (T_TCP_CCEP *cep);
extern void tcp_notify (T_NET_BUF *input, int code);
extern T_TCP_TIME tcp_rexmt_val (T_TCP_CCEP *cep);
extern void tcp_set_persist_timer (T_TCP_CCEP *cep);
extern void tcp_free_all_queue (void);
extern void tcp_alloc_auto_port (T_TCP_CCEP *cep);
extern ER tcp_alloc_port (T_TCP_CCEP *cep, UH portno);

/*
 *  tcp_find_cep -- ݡֹ椫 TCP ̿ü롣
 *
 *    : myaddr ϥۥȥХȥ
 */
extern T_TCP_CCEP *tcp_find_cep (UW myaddr, UH myport, UW peeraddr, UH peerport);

/* TCP ϥ */

extern void	tcp_output_task(VP_INT exinf);

#endif	/* of #ifndef _TCP_VAR_H_ */
