/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2001-2003 by Dep. of Computer Science and Engineering
 *                   Tomakomai National College of Technology, JAPAN
 *
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: discard.h,v 1.1.1.1 2004/04/21 00:45:44 abe Exp abe $
 */

#ifndef _DISCARD_H_
#define _DISCARD_H_

/* 
 *  DISCARD 
 */

#define TCP_DISCARD_SRV_STACK_SIZE	1024	/* TCP DISCARD ХΥå */
#define TCP_DISCARD_SRV_MAIN_PRIORITY	5	/* TCP DISCARD Хͥ */

/* 
 *  DISCARD 饤
 */

#define TCP_DISCARD_CLI_STACK_SIZE	1024	/* TCP DISCARD 饤ȥΥå */
#define TCP_DISCARD_CLI_MAIN_PRIORITY	5	/* TCP DISCARD 饤ȥͥ */

#define UDP_DISCARD_CLI_STACK_SIZE	1024	/* UDP DISCARD 饤ȥΥå */
#define UDP_DISCARD_CLI_MAIN_PRIORITY	5	/* UDP DISCARD 饤ȥͥ */

/* DISCARD 塼 */

#define NUM_DTQ_TCP_DISCARD_CLI	2		/* TCP DISCARD 塼	*/
#define NUM_DTQ_UDP_DISCARD_CLI	2		/* UDP DISCARD 塼	*/

/*
 *  ѿ
 */

extern BOOL	tcp_discard_cli_valid;

/*
 *  
 */

extern void tcp_discard_srv_task(VP_INT exinf);
extern void tcp_discard_cli_task(VP_INT exinf);

extern void udp_discard_cli_task(VP_INT exinf);

/*
 *  ؿ
 */

extern ER callback_nblk_tcp_discard_cli (ID cepid, FN fncd, VP p_parblk);

#endif	/* of #ifndef _DISCARD_H_ */
